#include <stdio.h>
#include <unistd.h>
#include "Buffer.h"

#define INCR(t) { if (++t >= MAX) t = 0; }

Buffer::Buffer() : wr(0), rd(0) {
  pthread_mutex_init(&mutex, NULL);
}

Buffer::~Buffer(void) {
  pthread_mutex_destroy(&mutex);
}

void Buffer::put(const char *data) {
  pthread_mutex_lock(&mutex);
  for (int i=0; i<9; i++)
    buf[wr][i] = *data++;
  INCR(wr);
  if (wr == rd) INCR(rd);
  pthread_mutex_unlock(&mutex);
}

bool Buffer::get(int session, char *data) {
  bool val = false;
  pthread_mutex_lock(&mutex);
  if (rd != wr) {// still something in buffer...
    for (int i=0; i<9; i++) {
      data[i] = buf[rd][i];
      //if (i) putchar(buf[rd][i]);
    }
    INCR(rd);
    val = true;
  }
  pthread_mutex_unlock(&mutex);
  return val;
}

void Buffer::dump(void) {
  printf("Buf: rd: %d, wr: %d\n", rd, wr);
}
