#ifndef SOCKET_H
#define SOCKET_H

#include <sys/un.h>

class SocketServer {
  struct sockaddr_un addr;
  int sk;

 public:
  SocketServer(const char *path);
  ~SocketServer();

  int run(void);

 protected:
  int send(int fd, const char *data, int len);
  virtual int doCmd(const char *cmd, int fd) = 0;
};

class SocketClient {
  struct sockaddr_un addr;
  int sk;
 public:
  SocketClient(const char *path);
  ~SocketClient();

  const char *get(const char *cmd);
};
#endif /*SOCKET_H*/
