# Bash completion file for ToBe Pilot

_pilot () {
  COMPREPLY=();
  local word="${COMP_WORDS[COMP_CWORD]}";
  if [ "$COMP_CWORD" -eq 1 ]; then
      COMPREPLY=($(compgen -W "stm esp usrs rst1 rst2 boot1 boot2 pwr 3v3 5v status -h" -- "$word"));
  elif [ "$COMP_CWORD" -eq 2 ]; then
    case ${COMP_WORDS[1]} in
      "stm"|"usr1"|"esp"|"usr2"|"usrs")
        COMPREPLY=($(compgen -W "serial enable disable reset flash -h" -- "$word"));
        ;;
      "pwr"|"3v3"|"5v")
        COMPREPLY=($(compgen -W "on off toggle -h" -- "$word"));
        ;;
      "rst1"|"rst2")
        COMPREPLY=($(compgen -W "run reset -h" -- "$word"));
        ;;
      "boot1"|"boot2")
        COMPREPLY=($(compgen -W "normal flash -h" -- "$word"));
        ;;
      "status")
        COMPREPLY=($(compgen -W "reset run ok err -h" -- "$word"));
        ;;
    esac
  fi
}

complete -F _pilot pilot

